; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; store byte to receive buffer (common)
; version 0.2 date 2006-02-28
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; store a data byte into receive buffer (common part)
; input: data byte in REG0, byte offset in REG1, bit number in REG2
; uses: Z, TMP, REG0, REG1, REG2
;  - used stack depth (without call to this function): 0
RECV_STORE_COMMON:
        mov     ZH,OUT_PTR_RECV_H               ; get base address of output buffer to put received data in
        mov     ZL,OUT_PTR_RECV_L
        mov     TMP,REG1                        ; byte (REG1) := byte_3 (REG1) * 3
        add     REG1,TMP
        add     REG1,TMP
        clr     TMP                             ; get destination address (dest_addr := base_addr + byte)
        add     ZL,REG1
        adc     ZH,TMP
        ldi     TMP,1                           ; get bit mask into REG2 (mask := 1 << bit)
        sbrc    REG2,0
        lsl     TMP
        sbrc    REG2,1
        lsl     TMP
        sbrc    REG2,1
        lsl     TMP
        sbrc    REG2,2
        swap    TMP
        mov     REG2,TMP
        mov     REG1,REG2                       ; get negated bit mask into REG1 (neg_mask := ~mask)
        com     REG1
        ld      TMP,Z                           ; store D0 of pixel value (D5 of received data byte)
        and     TMP,REG1
        sbrc    REG0,5
        or      TMP,REG2
        st      Z+,TMP
        ld      TMP,Z                           ; store D1 of pixel value (D6 of received data byte)
        and     TMP,REG1
        sbrc    REG0,6
        or      TMP,REG2
        st      Z+,TMP
        ld      TMP,Z                           ; store D2 of pixel value (D7 of received data byte)
        and     TMP,REG1
        sbrc    REG0,7
        or      TMP,REG2
        st      Z+,TMP
        ret
